package com.hai.dao;

import com.hai.entity.ApiProductConfig;
import com.hai.entity.ApiProductConfigExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface ApiProductConfigMapper extends ApiProductConfigMapperExt {
    @SelectProvider(type=ApiProductConfigSqlProvider.class, method="countByExample")
    long countByExample(ApiProductConfigExample example);

    @DeleteProvider(type=ApiProductConfigSqlProvider.class, method="deleteByExample")
    int deleteByExample(ApiProductConfigExample example);

    @Delete({
        "delete from api_product_config",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into api_product_config (product_id, merchants_id, ",
        "discount, discount_price, ",
        "operator_id, operator_name, ",
        "create_time, update_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{productId,jdbcType=BIGINT}, #{merchantsId,jdbcType=BIGINT}, ",
        "#{discount,jdbcType=DECIMAL}, #{discountPrice,jdbcType=DECIMAL}, ",
        "#{operatorId,jdbcType=BIGINT}, #{operatorName,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(ApiProductConfig record);

    @InsertProvider(type=ApiProductConfigSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(ApiProductConfig record);

    @SelectProvider(type=ApiProductConfigSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="merchants_id", property="merchantsId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount", property="discount", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<ApiProductConfig> selectByExample(ApiProductConfigExample example);

    @Select({
        "select",
        "id, product_id, merchants_id, discount, discount_price, operator_id, operator_name, ",
        "create_time, update_time, `status`, ext_1, ext_2, ext_3",
        "from api_product_config",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="merchants_id", property="merchantsId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount", property="discount", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    ApiProductConfig selectByPrimaryKey(Long id);

    @UpdateProvider(type=ApiProductConfigSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") ApiProductConfig record, @Param("example") ApiProductConfigExample example);

    @UpdateProvider(type=ApiProductConfigSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") ApiProductConfig record, @Param("example") ApiProductConfigExample example);

    @UpdateProvider(type=ApiProductConfigSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(ApiProductConfig record);

    @Update({
        "update api_product_config",
        "set product_id = #{productId,jdbcType=BIGINT},",
          "merchants_id = #{merchantsId,jdbcType=BIGINT},",
          "discount = #{discount,jdbcType=DECIMAL},",
          "discount_price = #{discountPrice,jdbcType=DECIMAL},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(ApiProductConfig record);
}