package com.hai.dao;

import com.hai.entity.BsIntegralRebate;
import com.hai.entity.BsIntegralRebateExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsIntegralRebateMapper extends BsIntegralRebateMapperExt {
    @SelectProvider(type=BsIntegralRebateSqlProvider.class, method="countByExample")
    long countByExample(BsIntegralRebateExample example);

    @DeleteProvider(type=BsIntegralRebateSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsIntegralRebateExample example);

    @Delete({
        "delete from bs_integral_rebate",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_integral_rebate (company_id, `type`, ",
        "product_id, percentage, ",
        "operator_id, operator_name, ",
        "create_time, update_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{companyId,jdbcType=BIGINT}, #{type,jdbcType=INTEGER}, ",
        "#{productId,jdbcType=BIGINT}, #{percentage,jdbcType=DECIMAL}, ",
        "#{operatorId,jdbcType=BIGINT}, #{operatorName,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsIntegralRebate record);

    @InsertProvider(type=BsIntegralRebateSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsIntegralRebate record);

    @SelectProvider(type=BsIntegralRebateSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="percentage", property="percentage", jdbcType=JdbcType.DECIMAL),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsIntegralRebate> selectByExample(BsIntegralRebateExample example);

    @Select({
        "select",
        "id, company_id, `type`, product_id, percentage, operator_id, operator_name, ",
        "create_time, update_time, `status`, ext_1, ext_2, ext_3",
        "from bs_integral_rebate",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="percentage", property="percentage", jdbcType=JdbcType.DECIMAL),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsIntegralRebate selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsIntegralRebateSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsIntegralRebate record, @Param("example") BsIntegralRebateExample example);

    @UpdateProvider(type=BsIntegralRebateSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsIntegralRebate record, @Param("example") BsIntegralRebateExample example);

    @UpdateProvider(type=BsIntegralRebateSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsIntegralRebate record);

    @Update({
        "update bs_integral_rebate",
        "set company_id = #{companyId,jdbcType=BIGINT},",
          "`type` = #{type,jdbcType=INTEGER},",
          "product_id = #{productId,jdbcType=BIGINT},",
          "percentage = #{percentage,jdbcType=DECIMAL},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsIntegralRebate record);
}