package com.hai.dao;

import com.hai.entity.BsProductPayType;
import com.hai.entity.BsProductPayTypeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsProductPayTypeMapper extends BsProductPayTypeMapperExt {
    @SelectProvider(type=BsProductPayTypeSqlProvider.class, method="countByExample")
    long countByExample(BsProductPayTypeExample example);

    @DeleteProvider(type=BsProductPayTypeSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsProductPayTypeExample example);

    @Delete({
        "delete from bs_product_pay_type",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_product_pay_type (product_type, source_id, ",
        "pay_type_id, pay_type_name, ",
        "pay_type_logo, operator_id, ",
        "operator_name, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{productType,jdbcType=INTEGER}, #{sourceId,jdbcType=BIGINT}, ",
        "#{payTypeId,jdbcType=INTEGER}, #{payTypeName,jdbcType=VARCHAR}, ",
        "#{payTypeLogo,jdbcType=VARCHAR}, #{operatorId,jdbcType=BIGINT}, ",
        "#{operatorName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsProductPayType record);

    @InsertProvider(type=BsProductPayTypeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsProductPayType record);

    @SelectProvider(type=BsProductPayTypeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="product_type", property="productType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="pay_type_id", property="payTypeId", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_type_name", property="payTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_type_logo", property="payTypeLogo", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsProductPayType> selectByExample(BsProductPayTypeExample example);

    @Select({
        "select",
        "id, product_type, source_id, pay_type_id, pay_type_name, pay_type_logo, operator_id, ",
        "operator_name, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_product_pay_type",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="product_type", property="productType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="pay_type_id", property="payTypeId", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_type_name", property="payTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_type_logo", property="payTypeLogo", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsProductPayType selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsProductPayTypeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsProductPayType record, @Param("example") BsProductPayTypeExample example);

    @UpdateProvider(type=BsProductPayTypeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsProductPayType record, @Param("example") BsProductPayTypeExample example);

    @UpdateProvider(type=BsProductPayTypeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsProductPayType record);

    @Update({
        "update bs_product_pay_type",
        "set product_type = #{productType,jdbcType=INTEGER},",
          "source_id = #{sourceId,jdbcType=BIGINT},",
          "pay_type_id = #{payTypeId,jdbcType=INTEGER},",
          "pay_type_name = #{payTypeName,jdbcType=VARCHAR},",
          "pay_type_logo = #{payTypeLogo,jdbcType=VARCHAR},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsProductPayType record);
}